Package serp.bytecode

# Class LookupSwitchInstruction

java.lang.Object
serp.bytecode.Instruction
serp.bytecode.JumpInstruction
serp.bytecode.LookupSwitchInstruction

All Implemented Interfaces:
  `BCEntity`, `InstructionPtr`, `VisitAcceptor`

public class LookupSwitchInstruction extends JumpInstruction
The `lookupswitch` instruction.

Author:
  Abe White

## Method Summary

Modifier and Type
Method
Description
`void`
`acceptVisit(BCVisitor visit)`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.
`LookupSwitchInstruction`
`addCase(int match, Instruction target)`
Add a case to this switch.
`int`
`getDefaultOffset()`
Synonymous with `JumpInstruction.getOffset()`.
`Instruction`
`getDefaultTarget()`
Synonymous with `JumpInstruction.getTarget()`.
`int[]`
`getMatches()`
Return the values of the case statements for this switch.
`int[]`
`getOffsets()`
`int`
`getStackChange()`
Return the number of stack positions this instruction pushes or pops during its execution.
`Instruction[]`
`getTargets()`
Return the targets of the case statements for this switch.
`void`
`replaceTarget(Instruction oldTarget, Instruction newTarget)`
Replace the given old, likely invalid, target with a new target.
`LookupSwitchInstruction`
`setCases(int[] matches, Instruction[] targets)`
Set the match-jumppt pairs for this switch.
`LookupSwitchInstruction`
`setDefaultOffset(int offset)`
Synonymous with `JumpInstruction.setOffset(int)`.
`LookupSwitchInstruction`
`setDefaultTarget(Instruction ins)`
Synonymous with `JumpInstruction.setTarget(serp.bytecode.Instruction)`.
`void`
`updateTargets()`
Use the byte indexes read from the class file to calculate and set references to the target instruction(s) for this ptr.

### Methods inherited from class serp.bytecode.JumpInstruction

`equalsInstruction, getOffset, getTarget, setOffset, setTarget`

### Methods inherited from class serp.bytecode.Instruction

`getByteIndex, getClassLoader, getCode, getLineNumber, getLogicalStackChange, getName, getOpcode, getPool, getProject, isValid`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface serp.bytecode.InstructionPtr

`getCode`

## Method Details

### getStackChange

public int getStackChange()
Description copied from class: `Instruction`
Return the number of stack positions this instruction pushes or pops during its execution.

Overrides:
  `getStackChange` in class `Instruction`
Returns:
  0 if the stack is not affected by this instruction, a positive number if it pushes onto the stack, and a negative number if it pops from the stack

### getDefaultTarget

public Instruction getDefaultTarget()
Synonymous with `JumpInstruction.getTarget()`.

### setDefaultTarget

public LookupSwitchInstruction setDefaultTarget(Instruction ins)
Synonymous with `JumpInstruction.setTarget(serp.bytecode.Instruction)`.

### getDefaultOffset

public int getDefaultOffset()
Synonymous with `JumpInstruction.getOffset()`.

### setDefaultOffset

public LookupSwitchInstruction setDefaultOffset(int offset)
Synonymous with `JumpInstruction.setOffset(int)`.

### setCases

public LookupSwitchInstruction setCases(int[] matches, Instruction[] targets)
Set the match-jumppt pairs for this switch.

Returns:
  this instruction, for method chaining

### getOffsets

public int[] getOffsets()

### getMatches

public int[] getMatches()
Return the values of the case statements for this switch.

### getTargets

public Instruction[] getTargets()
Return the targets of the case statements for this switch.

### addCase

public LookupSwitchInstruction addCase(int match, Instruction target)
Add a case to this switch.

Returns:
  this instruction, for method chaining

### updateTargets

public void updateTargets()
Description copied from interface: `InstructionPtr`
Use the byte indexes read from the class file to calculate and set references to the target instruction(s) for this ptr. This method will be called after the byte code has been read in for the first time and before it is written after modification.

Specified by:
  `updateTargets` in interface `InstructionPtr`
Overrides:
  `updateTargets` in class `JumpInstruction`

### replaceTarget

public void replaceTarget(Instruction oldTarget, Instruction newTarget)
Description copied from interface: `InstructionPtr`
Replace the given old, likely invalid, target with a new target. The new target Instruction is guaranteed to be in the same code block as this InstructionPtr.

Specified by:
  `replaceTarget` in interface `InstructionPtr`
Overrides:
  `replaceTarget` in class `JumpInstruction`

### acceptVisit

public void acceptVisit(BCVisitor visit)
Description copied from interface: `VisitAcceptor`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.

Specified by:
  `acceptVisit` in interface `VisitAcceptor`
Overrides:
  `acceptVisit` in class `JumpInstruction`